<%
'ListDay
'=======
function ListDay
	ListDay = "<OPTION value=0 selected></OPTION>" & vbcrlf
	for i=1 to 31
		ListDay = ListDay & "<OPTION value=" & i & ">" & i & "</OPTION>" & vbcrlf
	next 
end function

'ListMonth
'========
function ListMonth
	ListMonth = "<OPTION value=0 selected></OPTION>" & vbcrlf
	for i=1 to 12
		ListMonth = ListMonth & "<OPTION value=" & i & ">" & i & "</OPTION>" & vbcrlf
	next
end function

'ListYear
'adjust the i value for more years
'=================================
function ListYear
	ListYear = "<OPTION value=0 selected></OPTION>" & vbcrlf
	for i=2004 to 2008
		ListYear = ListYear & "<OPTION value=" & i & ">" & i & "</OPTION>" & vbcrlf
	next
end function

'ListHour
'========
function ListHour
	ListHour = "<OPTION value=00 selected>00</OPTION>" & vbcrlf
	for i=1 to 12
		if len(i)=1 then
			ListHour = ListHour & "<OPTION value=0" & i & ">0" & i & "</OPTION>" & vbcrlf
		else
			ListHour = ListHour & "<OPTION value=" & i & ">" & i & "</OPTION>" & vbcrlf
		end if
	next
end function

'ListMinute
'===========
function ListMinute
	ListMinute = "<OPTION value=00 selected>00</OPTION>" & vbcrlf
	for i=1 to 59
		if len(i)=1 then
			ListMinute = ListMinute & "<OPTION value=0" & i & ">0" & i & "</OPTION>" & vbcrlf
		else
			ListMinute = ListMinute & "<OPTION value=" & i & ">" & i & "</OPTION>" & vbcrlf
		end if
	next
end function

Function ConvertDate(dDate)

   If IsDate(dDate) = True Then
      dim dDay, dMonth, dYear, dHour, dMin

      dDay = Day(dDate)
      dMonth = Month(dDate)
      dYear   = Year(dDate)
      dHour = Hour(dDate)
      dMin = Minute(dDate)
	
      ConvertDate = dYear & "-" & Right(Cstr(dMonth + 100),2) & "-" & Right(Cstr(dDay + 100),2) & " " & dHour & ":" & dMin

   Else

      ConvertDate = Null

   End If

End Function

Function ConvertDate2(dDate)

   If IsDate(dDate) = True Then
      dim dDay, dMonth, dYear, dHour, dMin

      dDay = Day(dDate)
      dMonth = Month(dDate)
      dYear   = Year(dDate)
      dHour = Hour(dDate)
      dMin = Minute(dDate)
	
      ConvertDate2 = dYear & "-" & Right(Cstr(dMonth + 100),2) & "-" & Right(Cstr(dDay + 100),2)

   Else

      ConvertDate2 = Null

   End If

End Function

function PublishDocument(ID)
	Dim adoCnPublish
	Dim adoDocRs
	Dim adoPubRs
	
	set adoCnPublish = server.CreateObject("ADODB.Connection")
	set adoDocRs = Server.CreateObject("ADODB.Recordset")
	set adoPubRs = server.CreateObject("ADODB.Recordset")
	
	adoCnPublish.Open strConn2	
	
	adoCnPublish.BeginTrans
	
	'delete published document if any
	strSQL = "DELETE FROM [document_published] WHERE "
	strSQL = strSQL & "document_id = " & ID
	on error resume next
	adoCnPublish.execute strSQL
	if err.number <> 0 then
		adoCnPublish.RollbackTrans
		HandleError adoCnPublish,"common.asp - PublishDocument(ID) - Delete published document"
	end if
	

	'publish document now (insert into document_published)
	strSQL = "SELECT * FROM [document] WHERE document_id = " & ID
	on error resume next
	set adoDocRs = adoCnPublish.execute (strSQL)
	if err.number <> 0 then
		adoDocRs.Close
		set adoDocRs = nothing
		adoCnPublish.RollbackTrans
		HandleError adoCnPublish,"common.asp - PublishDocument(ID) - Select document"
	end if
	
	if not adoDocRs.EOF then
	
		'update document table
		'increment the version (the first segment +1 & the second segment=0)
		sVersion = adoDocRs("version")
		sFirstSegment = split(sVersion,".")(0)
		nSecondSegment = clng(split(sVersion,".")(1))
		sFirstSegment = sFirstSegment + 1
		sVersion = sFirstSegment & ".0"
		
		nParentDocID = adoDocRs("parent_document_id")
	
		adoPubRs.ActiveConnection = adoCnPublish
		adoPubRs.CursorType = 3 'static cursor
		adoPubRs.LockType = 3 'optimistic locking
		adoPubRs.Open "SELECT * FROM document_published WHERE 1<>1"
		adoPubRs.AddNew
		adoPubRs("document_id") = adoDocRs("document_id")
		adoPubRs("parent_document_id") = adoDocRs("parent_document_id")
		adoPubRs("position") = adoDocRs("position")
		adoPubRs("template_id") = adoDocRs("template_id")
		adoPubRs("type") = adoDocRs("type")
		adoPubRs("title") = adoDocRs("title")
		adoPubRs("sub_title") = adoDocRs("sub_title")
		adoPubRs("link_text") = adoDocRs("link_text")
		adoPubRs("abstract") = adoDocRs("abstract")
		adoPubRs("content") = adoDocRs("content")
		adoPubRs("search_keywords") = adoDocRs("search_keywords")
		adoPubRs("search_description") = adoDocRs("search_description")
		adoPubRs("author_id") = adoDocRs("author_id")
		adoPubRs("last_updated_by") = adoDocRs("last_updated_by")
		adoPubRs("date_created") = adoDocRs("date_created")
		adoPubRs("date_last_updated") = adoDocRs("date_last_updated")
		adoPubRs("date_published") = ConvertDate(now())
		adoPubRs("file_name") = adoDocRs("file_name")
		adoPubRs("file_size") = adoDocRs("file_size")
		adoPubRs("public") = adoDocRs("public")
		adoPubRs("version") = sVersion ' increased version
		adoPubRs("date_start") = adoDocRs("date_start")
		adoPubRs("date_end") = adoDocRs("date_end")
		adoPubRs("hidden") = adoDocRs("hidden")
		
		on error resume next
		adoPubRs.Update
		if err.number <> 0 then
			adoPubRs.Close
			adoDocRs.Close
			set adoPubRs = nothing
			set adoDocRs = nothing
			adoCnPublish.RollbackTrans
			HandleError adoCnPublish,"common.asp - PublishDocument(ID) - Add published document"
		end if
		
		adoPubRs.Close 
	end if
	
	adoDocRs.Close 
	
	'Rearrange position ~~~~~~~~~~~
	if Not IsNull(nParentDocID) then 'if not a contentblock, etc	
		strSQL = "SELECT document_id,[position] FROM [document] " & _
				" WHERE parent_document_id = " & nParentDocID & _
				" AND [type]='content' ORDER BY [position] ASC"
		set adoRsIn = adoCnPublish.Execute(strSQL)
		do while not adoRsIn.EOF
			strSQL = "UPDATE [document_published] SET [position]=" & adoRsIn("position") & _
					" WHERE document_id = " & adoRsIn("document_id")
			on error resume next
			adoCnPublish.Execute strSQL
			if err.number <> 0 then
				adoCnPublish.RollbackTrans
				HandleError adoCnPublish,"common.asp - PublishDocument(ID) - Rearrange position"
			end if	
			adoRsIn.MoveNext 
		loop
		adoRsIn.Close
		set adoRsIn = nothing	
	end if
	'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	
	set adoDocRs = nothing
	set adoPubRs = nothing
	
	'set approval status to "published" and increased version
	strSQL = "UPDATE [document] SET approval_status = 'published'"
	strSQL = strSQL & ",date_last_published = #" & ConvertDate(now()) & "# "
	strSQL = strSQL & ",[version]='" & sVersion & "' "
	strSQL = strSQL & "WHERE document_id = " & ID
	on error resume next
	adoCnPublish.Execute (strSQL)
	if err.number <> 0 then
		adoCnPublish.RollbackTrans
		HandleError adoCnPublish,"common.asp - PublishDocument(ID) - Update approval status to 'published'"
	end if
	
	adoCnPublish.CommitTrans
	adoCnPublish.Close
	set adoCnPublish = nothing
	
end function

function ReleaseDocument(ID)
	Dim adoCnRelease
	Dim adoRs
	Dim adoRs2
	Set adoCnRelease = Server.CreateObject("ADODB.Connection")
	Set adoRs = Server.CreateObject("ADODB.Recordset")
	Set adoRs2 = Server.CreateObject("ADODB.Recordset")
	adoCnRelease.Open strConn2
	adoCnRelease.BeginTrans
	
	strSQL = "UPDATE [document] SET approval_status='released' "
	strSQL = strSQL & "WHERE document_id = " & ID
	on error resume next
	adoCnRelease.Execute strSQL
	if err.number <> 0 then
		adoCnRelease.RollbackTrans
		HandleError adoCnRelease,"common.asp - ReleaseDocument(ID) - Update approval status to 'released'"
	end if	
		
	'populate approval_progress table
	'check first if it has been populated before
	strSQL = "SELECT * FROM approval_progress WHERE "
	strSQL = strSQL & "document_id = " & ID
	set adoRs = adoCnRelease.Execute(strSQL)
	if not adoRs.EOF then 'it has been populated before
		'set 'not_approved' status to 'pending'
		strSQL = "UPDATE approval_progress SET "
		strSQL = strSQL & "review_status = 'pending' "
		strSQL = strSQL & "WHERE document_id = " & ID & " "
		strSQL = strSQL & "AND review_status = 'not_approved'"
		on error resume next
		adoCnRelease.Execute strSQL
		if err.number <> 0 then
			adoCnRelease.RollbackTrans
			HandleError adoCnRelease,"common.asp - ReleaseDocument(ID) - Update review status to 'pending'"
		end if			
	else 
		'empty, populate records
		strSQL = "SELECT approval_point_id,[stage],[email] FROM approval_point, [user] "
		strSQL = strSQL & "WHERE [approval_point].[user_id] = [user].[user_id] AND approval_scheme_id = " & nApprovalID & " ORDER BY [stage] ASC"
		adoRs2.Open strSQL,adoCnRelease
		do while not adoRs2.EOF
			if adoRs2("stage") = 1 then
				strSQL = "INSERT INTO approval_progress(document_id,approval_point_id,review_status) "
				strSQL = strSQL & "VALUES(" & ID & "," & adoRs2("approval_point_id") & ",'pending')"
			else
				strSQL = "INSERT INTO approval_progress(document_id,approval_point_id) "
				strSQL = strSQL & "VALUES(" & ID & "," & adoRs2("approval_point_id") & ")"
			end if
			'==========================Send Email=================================
			sMessage = ""
			sMessage = sMessage & "You have one new document that needs your approval"
			sMessage = sMessage & "<BR>"
			sMessage = sMessage & "Please login to the Site Composer control panel to review the document."
			SendEmail "Approve Me",sMessage,Session("email"),adoRs2("email")
			'=====================================================================
			on error resume next
			adoCnRelease.Execute strSQL
			if err.number <> 0 then
				adoCnRelease.RollbackTrans
				HandleError adoCnRelease,"common.asp - ReleaseDocument(ID) - Populate approval progress"
			end if	
				
			adoRs2.MoveNext 
		loop
		adoRs2.Close
	end if
	adoRs.Close
	
	adoCnRelease.CommitTrans 		
	set adoRs = nothing
	set adoRs2 = nothing
	adoCnRelease.Close
	set adoCnRelease = nothing
		
end function


Function ArchieveDocument(ID)

	Dim adoCnArchive
	Dim adoRsArchive
	Dim adoRsDoc
	Set adoCnArchive = Server.CreateObject("ADODB.Connection")
	Set adoRsArchive = Server.CreateObject("ADODB.Recordset")
	set adoRsDoc = Server.CreateObject("ADODB.Recordset")
	
	adoCnArchive.Open strConn2

	strSQL = "SELECT * FROM [document] "
	strSQL = strSQL & "WHERE document_id = " & ID
			
	set adoRsDoc = adoCnArchive.Execute (strSQL)
			
	if not adoRsDoc.EOF then
		adoRsArchive.ActiveConnection = adoCnArchive
		adoRsArchive.CursorType = 3 'static cursor
		adoRsArchive.LockType = 3 'optimistic locking
		adoRsArchive.Open "SELECT * FROM document_archieved WHERE 1<>1"
		adoRsArchive.AddNew
		adoRsArchive("document_id") = adoRsDoc("document_id")
		adoRsArchive("parent_document_id") = adoRsDoc("parent_document_id")
		adoRsArchive("position") = adoRsDoc("position")
		adoRsArchive("category_id") = adoRsDoc("category_id")
		adoRsArchive("template_id") = adoRsDoc("template_id")
		adoRsArchive("type") = adoRsDoc("type")
		adoRsArchive("title") = adoRsDoc("title")
		adoRsArchive("sub_title") = adoRsDoc("sub_title")
		adoRsArchive("link_text") = adoRsDoc("link_text")
		adoRsArchive("abstract") = adoRsDoc("abstract")
		adoRsArchive("content") = adoRsDoc("content")
		adoRsArchive("search_keywords") = adoRsDoc("search_keywords")
		adoRsArchive("search_description") = adoRsDoc("search_description")
		adoRsArchive("author_id") = adoRsDoc("author_id")
		adoRsArchive("date_created") = adoRsDoc("date_created")
		adoRsArchive("last_updated_by") = adoRsDoc("last_updated_by")
		adoRsArchive("date_archieved") = ConvertDate(now())
		adoRsArchive("file_name") = adoRsDoc("file_name")
		adoRsArchive("file_size") = adoRsDoc("file_size")
		adoRsArchive("version") = adoRsDoc("version")
		adoRsArchive("date_last_published") = adoRsDoc("date_last_published")
		adoRsArchive("date_start") = adoRsDoc("date_start")
		adoRsArchive("date_end") = adoRsDoc("date_end")
		adoRsArchive("public") = adoRsDoc("public")
		
		on error resume next
		adoRsArchive.Update
		if err.number <> 0 then
			adoRsArchive.Close
			adoRsDoc.Close
			set adoRsArchive = nothing
			set adoRsDoc = nothing
			HandleError adoCnArchive,"common.asp - ArchiveDocument(ID)"
		end if
		adoRsArchive.Close 
	
	end if
	adoRsDoc.Close
	set adoRsDoc = nothing
	set adoRsArchive = nothing
	adoCnArchive.Close
	set adoCnArchive = nothing
	
End Function




Function CheckInDocument(ID)
	Dim adoCnIn
	Dim adoRsIn
	Set adoCnIn = Server.CreateObject("ADODB.Connection")
	Set adoRsIn = Server.CreateObject("ADODB.Recordset")
	adoCnIn.Open strConn2
	adoCnIn.BeginTrans
	'***************************************************************************
	'	STEP 1: Archive record to document_archieved table
	'			(nLastUpdatedBy & dDateLastUpdated tetap)
	'***************************************************************************
	ArchieveDocument ID

	'***************************************************************************
	'	STEP 2: 
	'		a. Read document from [document_working] table
	'		b. Move (Update) to [document] table & increase the version
	'			(nLastUpdatedBy & dDateLastUpdated berubah)
	'			{checked_out_by & date_checked_out null)
	'			(type tdk perlu diubah)
	'***************************************************************************
	adoRsIn.Open "Select * From document_working where document_id=" & ID,adoCnIn

	nDocWorkingID = adoRsIn("document_working_id")
	nDocID = adoRsIn("document_id")
	nParentDocID = adoRsIn("parent_document_id")
	nCatID = adoRsIn("category_id")
	nTemplateID = adoRsIn("template_id")
	sTitle = "" & adoRsIn("title")
	sSubTitle = "" & adoRsIn("sub_title")
	sLinkText = "" & adoRsIn("link_text")
	sAbstract = "" & adoRsIn("abstract")
	sContent = "" & adoRsIn("content")
	sSearchKey = "" & adoRsIn("search_keywords")
	sSearchDesc = "" & adoRsIn("search_description")
	nUserID = Session("user_id")'logged-in user
	sFileName = "" & adoRsIn("file_name")
	dStartDate = adoRsIn("date_start")
	dEndDate = adoRsIn("date_end")
	sPublic = "" & adoRsIn("public")
	sNote = "" & adoRsIn("note")
	sVersion = "" & adoRsIn("version")
	nSitePos = adoRsIn("position_document_temp")
	sAfter = "" & adoRsIn("position_desc")
	sSpecifyNewPosition = "" & adoRsIn("position_apply_new")
	sHidden = "" & adoRsIn("hidden")
		
	strSQLPosition = ""
	if sSpecifyNewPosition = "yes" then

			if sAfter="under" then
				strSQL = "SELECT Max([position]) FROM [document] where parent_document_id=" & nSitePos
				set adoRsIn = adoCnIn.Execute (strSQL)
				if not adoRsIn.EOF then
					if IsNull(adoRsIn(0)) then
						nPos = 0.5
					else
						nPos = adoRsIn(0) + 0.5
					end if
				end if
				adoRsIn.Close
				set adoRsIn = nothing
				strSQLPosition = ",[position] = " & nPos
			else
				strSQL = "SELECT [position] FROM [document] "
				strSQL = strSQL & "WHERE document_id = " & nSitePos
				set adoRsIn = adoCnIn.Execute (strSQL)
				if not adoRsIn.EOF then

					nPos = adoRsIn("position")
					if sAfter="after" then
						nPos = nPos + 0.5
					else
						nPos = nPos - 0.5
					end if
					strSQLPosition = ",[position] = " & nPos
				else 
					'ini tdk mungkin terjadi, krn form sdh di-validate
				end if
				adoRsIn.Close
				set adoRsIn = nothing
			end if

	else
		'no change
		strSQLPosition = ""	
	end if	


	'update document table
	'increment the version first (the second segment +1)
	sFirstSegment = split(sVersion,".")(0)
	nSecondSegment = clng(split(sVersion,".")(1))
	nSecondSegment = nSecondSegment + 1
	sVersion = sFirstSegment & "." & cstr(nSecondSegment)
			
	strSQL = "UPDATE [document] "
	strSQL = strSQL & "SET "
	if IsNull(nParentDocID) then
		strSQL = strSQL & "parent_document_id = null"
	else
		strSQL = strSQL & "parent_document_id = " & nParentDocID
	end if
	strSQL = strSQL & ",category_id = " & nCatID
	strSQL = strSQL & ",template_id = " & nTemplateID
	strSQL = strSQL & strSQLPosition
	strSQL = strSQL & ",[title] = '" & replace(sTitle,"'","''") & "'"
	strSQL = strSQL & ",sub_title = '" & replace(sSubTitle,"'","''") & "'"
	strSQL = strSQL & ",link_text = '" & replace(sLinkText,"'","''") & "'"
	strSQL = strSQL & ",[abstract] = '" & replace(sAbstract,"'","''") & "'"
	strSQL = strSQL & ",[content] = '" & replace(sContent,"'","''") & "'"
	strSQL = strSQL & ",search_keywords = '" & replace(sSearchKey,"'","''") & "'"
	strSQL = strSQL & ",search_description = '" & replace(sSearchDesc,"'","''") & "'"
	strSQL = strSQL & ",last_updated_by = " & nUserID
	strSQL = strSQL & ",checked_out_by = null"
	strSQL = strSQL & ",date_checked_out = null"
	strSQL = strSQL & ",date_last_updated = #" & ConvertDate(now()) & "#"
	strSQL = strSQL & ",document_status = 'checked-in'"
	strSQL = strSQL & ",approval_status = 'working'"
	strSQL = strSQL & ",file_name = '" & replace(sFileName,"'","''") & "'"
	strSQL = strSQL & ",[version] = '" & sVersion & "'"
	if IsNull(dStartDate) then 
		strSQL = strSQL & ",date_start=null"
	else
		strSQL = strSQL & ",date_start=#" & ConvertDate(dStartDate) & "#"
	end if
	if IsNull(dEndDate) then 
		strSQL = strSQL & ",date_end=null"
	else
		strSQL = strSQL & ",date_end=#" & ConvertDate(dEndDate) & "#"
	end if
	strSQL = strSQL & ",[public] = '" & sPublic & "'"
	strSQL = strSQL & ",[note] = '" & replace(sNote,"'","''") & "' "
	strSQL = strSQL & ",[hidden] = '" & sHidden & "' "
	strSQL = strSQL & "WHERE document_id = " & nDocID
			
	on error resume next
	adoCnIn.Execute (strSQL)
	if err.number <> 0 then
		adoCnIn.RollbackTrans
		HandleError adoCnIn,"common.asp - CheckInDocument(ID) - Update document"
	end if	

	're-arrange the position for peer documents
	if Not IsNull(nParentDocID) then 'if not a contentblock, etc		
		if sSpecifyNewPosition = "yes" then'tapi kalau contentblock, sSpecifyNewPosition=no

				strSQL = "SELECT document_id,[position] FROM [document] "
				strSQL = strSQL & "WHERE parent_document_id = " & nParentDocID & " "
				strSQL = strSQL & "AND [type]='content' ORDER BY [position] ASC"
				set adoRsIn = adoCnIn.Execute(strSQL)
				n=0
				do while not adoRsIn.EOF
					n=n+1
					strSQL = "UPDATE [document] SET [position]=" & n & " "
					strSQL = strSQL & "WHERE document_id = " & adoRsIn("document_id")
					on error resume next
					adoCnIn.Execute strSQL
					if err.number <> 0 then
						adoCnIn.RollbackTrans
						HandleError adoCnIn,"common.asp - CheckInDocument(ID) - Rearrange position"
					end if	
					adoRsIn.MoveNext 
				loop
				adoRsIn.Close
				set adoRsIn = nothing

		end if	
	end if

	'***************************************************************************
	'	STEP 3: delete temporary working document in document_working table
	'***************************************************************************
	strSQL = "DELETE FROM document_working "
	strSQL = strSQL & "WHERE document_id = " & nDocID
	on error resume next
	adoCnIn.Execute (strSQL)
	if err.number <> 0 then
		adoCnIn.RollbackTrans
		HandleError adoCnIn,"common.asp - CheckInDocument(ID) - Delete working document"
	end if	
	
	set adoRsIn = nothing
	adoCnIn.CommitTrans 
	adoCnIn.Close
	set adoCnIn = nothing
End Function



function CheckOutDocument(ID)
	Dim adoCnOut
	Dim adoRsOut
	Set adoCnOut = Server.CreateObject("ADODB.Connection")
	Set adoRsOut = Server.CreateObject("ADODB.Recordset")
	adoCnOut.Open strConn2	
	adoCnOut.BeginTrans
	'============================================
	'I. Load document from database for editing
	'============================================
	strSQL = "SELECT * FROM [document] WHERE document_id = " & ID
	
	set adoRsOut = adoCnOut.Execute(strSQL)
	if not adoRsOut.EOF then
			nDocID = adoRsOut("document_id")
			nParentID = adoRsOut("parent_document_id")
			nCatID = adoRsOut("category_id")
			nTemplateID = adoRsOut("template_id")
			sType = "" & adoRsOut("type")
			sTitle = "" & adoRsOut("title")
			sSubTitle = "" & adoRsOut("sub_title")
			sLinkText = "" & adoRsOut("link_text")
			sAbstract = "" & adoRsOut("abstract")
			sContent = "" & adoRsOut("content")
			sSearchKey = "" & adoRsOut("search_keywords")
			sSearchDesc = "" & adoRsOut("search_description")
			nAuthor = adoRsOut("author_id")'the author id
			nLastUpdatedBy = adoRsOut("last_updated_by")'the id of the person
			nCheckedOutBy = Session("user_id")'logged-in user
			dDateCreated = adoRsOut ("date_created")
			dDateLastUpdated = adoRsOut("date_last_updated")
			sFileName = "" & adoRsOut ("file_name")
			nFileSize = adoRsOut ("file_size")
			if isnull(nFileSize) then
				nSizeTemp = "null"
			else
				nSizeTemp = nFileSize
			end if
			sVersion = "" & adoRsOut ("version")
			dStartDate = adoRsOut ("date_start")
			if isnull(dStartDate) then
				dStartTemp = "null"
			else
				dStartTemp = "#" & ConvertDate(dStartDate) & "#"
			end if
			dEndDate = adoRsOut ("date_end")
			if isnull(dEndDate) then
				dEndTemp = "null"
			else
				dEndTemp = "#" & ConvertDate(dEndDate) & "#"
			end if
			dLastPublished = adoRsOut ("date_last_published")
			if isnull(dLastPublished) then
				dPublishTemp = "null"
			else
				dPublishTemp = "#" & ConvertDate(dLastPublished) & "#"
			end if
			if isnull(nParentID) then
				nParentTemp = "null"
			else
				nParentTemp = nParentID
			end if
			sPublic = "" & adoRsOut("public")
			sNote = "" & adoRsOut ("note")
			nPosition = adoRsOut("position")
			if isnull(nPosition) then
				nPosTemp = "null"
			else
				nPosTemp = nPosition
			end if
			
			sHidden = adoRsOut("hidden")
	end if
	adoRsOut.Close
	set adoRsOut = nothing
	
	
	'================================================================
	'II. insert temporary working document in document_working table
	'================================================================
	strSQL = "INSERT INTO [document_working]"
	strSQL = strSQL & "(document_id,parent_document_id,position_document_temp,category_id,template_id"
	strSQL = strSQL & ",[type],title,sub_title"
	strSQL = strSQL & ",link_text,abstract,[content]"
	strSQL = strSQL & ",search_keywords,search_description,user_id,author_id"
	strSQL = strSQL & ",date_last_saved,file_name,file_size,version,date_start"
	strSQL = strSQL & ",date_end,date_last_published,[public],[note],[hidden])"
	strSQL = strSQL & "VALUES"
	strSQL = strSQL & "(" & nDocID & "," & nParentTemp & ",null," & nCatID & "," & nTemplateID
	strSQL = strSQL & ",'" & sType & "','" & replace(sTitle,"'","''") & "','" & replace(sSubTitle,"'","''") & "'"
	strSQL = strSQL & ",'" & replace(sLinkText,"'","''") & "','" & replace(sAbstract,"'","''") & "','" & replace(sContent,"'","''") & "'"
	strSQL = strSQL & ",'" & replace(sSearchKey,"'","''") & "','" & replace(sSearchDesc,"'","''") & "'," & nCheckedOutBy & "," & nAuthor
	strSQL = strSQL & ",#" & ConvertDate(now()) & "#,'" & replace(sFileName,"'","''") & "'," & nSizeTemp & ",'" & sVersion & "'," & dStartTemp
	strSQL = strSQL & "," &  dEndTemp & "," &  dPublishTemp & ",'" & sPublic & "','" & replace(sNote,"'","''") & "','" & sHidden & "')" 
	on error resume next
	adoCnOut.Execute (strSQL)
	if err.number <> 0 then
		adoCnOut.RollbackTrans
		HandleError adoCnOut,"common.asp - CheckOutDocument(ID) - Insert into document working table"
	end if	
	'=====================
	'III. update status
	'=====================
	strSQL= "UPDATE [document] "
	strSQL = strSQL & "SET checked_out_by =" & nCheckedOutBy & ","
	strSQL = strSQL & "date_checked_out =#" & ConvertDate(now()) & "#,"
	strSQL = strSQL & "document_status = 'checked-out',"
	strSQL = strSQL & "approval_status = 'working' "
	strSQL = strSQL & "WHERE document_id = " & nDocID
	on error resume next
	adoCnOut.Execute strSQL
	if err.number <> 0 then
		adoCnOut.RollbackTrans
		HandleError adoCnOut,"common.asp - CheckOutDocument(ID) - Update status"
	end if
	
	adoCnOut.CommitTrans
	adoCnOut.Close
	set adoCnOut = nothing

End Function


sub HandleError(obj,pagename)
	obj.close
	set obj = nothing
	strErr = "<HTML><TITLE>Page Error</TITLE>"
	strErr = strErr & "<BODY><H1>Unable to process your request.</H1>"
	strErr = strErr & "<H3>Page: " & pagename & ".</H3>"
	strErr = strErr & "<H3>Number: " & err.Source & ".</H3>"
	strErr = strErr & "<H3>Problem Description: " & err.Description & "</H3>"
	strErr = strErr & "<H3>Please contact your administrator.</H3>"
	strErr = strErr & "</BODY></HTML>"
	Response.Write strErr
	Response.End
end sub

function SendEmail (sSubject,sContent,sSender,sReceiver)
	
	'===============================================
	'example of using CDONTS email component
	'===============================================
	'Set objMail = Server.CreateObject("CDONTS.NewMail")
	'objMail.To = sReceiver
	'objMail.From = sSender
	'objMail.Subject = sSubject
	'objMail.Body = sContent
	'objMail.Send                           
	'Set objMail = Nothing  

end function
%>