<%Response.Expires=0%>
<!-- #INCLUDE FILE='include/connection.asp' -->
<!-- #INCLUDE FILE='include/common.asp' -->
<%
'~~~~~~~~~~~~~~~ SECURITY ~~~~~~~~~~~~~~~
if Session("user_id")="" then 
	Response.Write "Session Expired. Please re-login."
	response.end
end if
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

'***************************************************************************
'	STEP 1: Check if it is the author
'***************************************************************************
bAuthorized=false
set adoCnCheck = Server.CreateObject("ADODB.Connection")
set adoRsCheck = Server.CreateObject("ADODB.Recordset")
	
adoCnCheck.Open strConn2
strSQL = "SELECT author_id,[title] FROM [document] where document_id = " & Request("id")
adoRsCheck.Open strSQL,adoCnCheck
if not adoRsCheck.EOF then
	if Session("user_id")= adoRsCheck("author_id") then
		bAuthorized=true
		sTitle = adoRsCheck("title")
	end if
end if
adoRsCheck.Close
adoCnCheck.Close
set adoRsCheck = nothing
set adoCnCheck = nothing

if bAuthorized=false then
	'Not Authorized, stop execution.
	Response.Write "Not Authorized."
	response.end	
end if

nPage = trim(Request.QueryString("page_no"))
if nPage =  "" then
	nPage = 1
end if

'create header
strHTMLHeader = ""
strHTMLHeader = strHTMLHeader & "<TR style='background:#e7e7e7'>"
strHTMLHeader = strHTMLHeader & "<TD style='padding:2'><b>Select</b></TD><TD style='padding:2'><b>Version</b></TD><TD style='padding:2'><b>Date Archived</b></TD><TD style='padding:2'><b>Last Updated By</b></TD>"
strHTMLHeader = strHTMLHeader & "</TR>"
strHTMLResult = ""
sView = "disabled"

if Request.QueryString("command")="rollback" then
	set adoCnArc = Server.CreateObject("ADODB.Connection")
	set adoRsArc = Server.CreateObject("ADODB.Recordset")
	
	adoCnArc.Open strConn2
	adoCnArc.BeginTrans
	
	'***********************************
	'	Check document availability.
	'***********************************
	bAvailable=false
	set adoRsArc = adoCnArc.execute("SELECT [title],document_status,approval_status,[version] FROM [document] where document_id=" & Request.QueryString("id"))
	sDocStatus = adoRsArc("document_status")
	sApprovalStatus = adoRsArc("approval_status")
	sVersion = adoRsArc("version")
	sTitle = adoRsArc("title")
	if sDocStatus = "checked-in" AND (sApprovalStatus="working" OR sApprovalStatus="rejected" OR sApprovalStatus="published") then
		bAvailable=true
	end if	

	if bAvailable=false then
		'Not Available, stop execution.
		adoRsArc.close
		adoCnArc.RollbackTrans
		adoCnArc.close
		set adoRsArc = nothing
		set adoCnArc = nothing
		Response.Write "Document is not available for rollback."
		response.end
	end if

	set adoRsArc = adoCnArc.execute("SELECT [content],[abstract],[version] FROM document_archieved WHERE document_archieved_id = " & Request.Form("optArchived"))
	SContentTemp = "" & adoRsArc("content")
	sAbstractTemp = "" & adoRsArc("abstract")
	sVersionTemp = adoRsArc("version")
	adoRsArc.close
	set adoRsArc = nothing
	
	s1=""
	s2=""
	
	if Request.Form("chkContent") = "on" then
		s1 = "[content] = '" & replace(sContentTemp,"'","''") & "'"
	end if
	if Request.Form("chkAbstract") = "on" then
		s2 = "[abstract] = '" & replace(sAbstractTemp,"'","''") & "'"
	end if
	
	'increment the version (the second segment +1)
	sFirstSegment = split(sVersion,".")(0)
	nSecondSegment = clng(split(sVersion,".")(1))
	nSecondSegment = nSecondSegment + 1
	sVersion = sFirstSegment & "." & cstr(nSecondSegment)
	
	strSQL1 = "UPDATE [document] SET last_updated_by = " & Session("user_id")
	strSQL1 = strSQL1 & ",date_last_updated = #" & ConvertDate(now()) & "#"
	strSQL1 = strSQL1 & ",approval_status = 'working'"
	strSQL1 = strSQL1 & ",[version] = '" & sVersion & "'"
	if s1 <> "" then
		strSQL1 = strSQL1 & "," & s1
	end if
	if s2<> "" then
		strSQL1 = strSQL1 & "," & s2
	end if
	strSQL1 = strSQL1 & " WHERE document_id = " & Request.QueryString("id")
	
	'*****************************************
	'1.Archive document
	'2.Update the content/abstract of current doc with the selected archive version
	'*****************************************
	ArchieveDocument Request.QueryString("id")
	on error resume next
	adoCnArc.execute strSQL1
	if err.number <> 0 then
		adoCnArc.RollbackTrans
		HandleError adoCnArc,"archive_list.asp - Rollback content/abstract"
	end if
	
	adoCnArc.CommitTrans
	adoCnArc.close
	set adoCnArc = nothing
	
	sView = ""
	strMsg = sTitle & " has been rolled-back to ver " & sVersionTemp & " successfully."
	strHTMLResult = GetArchiveData(Request.QueryString("id"),nPage)

elseif Request.QueryString("command")="delete" then
	'delete the selected archive record
	set adoCnArc = Server.CreateObject("ADODB.Connection")
	
	adoCnArc.Open strConn2
	on error resume next
	adoCnArc.execute "DELETE FROM document_archieved WHERE document_archieved_id = " & Request.Form("optArchived")
	if err.number <> 0 then
		HandleError adoCnArc,"archive_list.asp - Delete Archive"
	end if
	adoCnArc.close
	set adoCnArc = nothing
	sView = ""
	strHTMLResult = GetArchiveData(Request.QueryString("id"),nPage)

else
	'document must be checked-in and (working/rejected/published)
	'if the above conditions are not met, disable the rollback button
	bAllow = false
	strMsg = ""
	strSQL = "SELECT document_id,[title],document_status,approval_status FROM [document] WHERE "
	strSQL = strSQL & "document_id = " & Request.QueryString("id")
	
	set adoCnArc = Server.CreateObject("ADODB.Connection")
	set adoRsArc = Server.CreateObject("ADODB.Recordset")
	
	adoCnArc.Open strConn2
	set adoRsArc = adoCnArc.Execute (strSQL)
	if not adoRsArc.EOF then
		sTitle = adoRsArc("title")
		if adoRsArc("document_status")= "checked-in" then
			if adoRsArc("approval_status") = "working" or _
				adoRsArc("approval_status") = "rejected" or _
				adoRsArc("approval_status") = "published" then
				bAllow = true
				strMsg = ""
			else
				bAllow = false
				strMsg = "Doc approval status is "
				strMsg = strMsg & replace(adoRsArc("approval_status"),"_"," ") & ". "
				strMsg = strMsg & "Rollback and Delete are not allowed now."
			end if
		else
			bAllow = false
			strMsg = "Doc is being "
			strMsg = strMsg & adoRsArc("document_status") & ". "
			strMsg = strMsg & "Rollback and Delete are not allowed now."
		end if
	else
		bAllow = false
		strMsg = "Document is no longer available."
	end if
	
	adoRsArc.Close
	adoCnArc.Close
	set adoRsArc = nothing
	set adoCnArc = nothing
	
	if bAllow = false then
		sView = "disabled"
	else
		sView = ""
	end if
	
	strHTMLResult = GetArchiveData(Request.QueryString("id"),nPage)

end if

function GetArchiveData(ID,page)
	set adoCnGet = Server.CreateObject("ADODB.Connection")
	set adoRsGet = Server.CreateObject("ADODB.Recordset")
	
	nRecordPerPage = 10
	adoCnGet.Open strConn2
	adoRsGet.CursorType = 3
	adoRsGet.PageSize = nRecordPerPage
	
	strSQL = "SELECT document_archieved_id,[version],date_archieved,last_updated_by,full_name "
	strSQL = strSQL & "FROM document_archieved,[user] WHERE "
	strSQL = strSQL & "document_archieved.last_updated_by = [user].user_id AND "
	strSQL = strSQL & "document_id = " & ID & " "
	strSQL = strSQL & "ORDER BY date_archieved DESC"
	adoRsGet.Open strSQL,adoCnGet
	
	if not adoRsGet.EOF then
		adoRsGet.AbsolutePage = page
	else
		'no archived records, disable buttons and rollback options
		sView = "disabled"
	end if
	nCounter = 0
	strHTML = ""
	
	do while not adoRsGet.EOF AND nCounter < nRecordPerPage
		strHTML = strHTML & "<TR>"
		if nCounter = 0 then
		strHTML = strHTML & "<TD style='padding-left:2'><input type='radio' NAME='optArchived' ID='optArchived' VALUE='" & adoRsGet("document_archieved_id") & "' checked></TD>"
		else
		strHTML = strHTML & "<TD style='padding-left:2'><input type='radio' NAME='optArchived' ID='optArchived' VALUE='" & adoRsGet("document_archieved_id") & "'></TD>"
		end if
		strHTML = strHTML & "<TD style='padding-left:2'><a href='javascript:void(0)' onclick=openWindowDialog('archive_view.asp?id=" & adoRsGet("document_archieved_id") & "',750,650)>" & adoRsGet("version") & "</a></TD>"
		strHTML = strHTML & "<TD style='padding-left:2'>" & adoRsGet("date_archieved") & "</TD>"
		strHTML = strHTML & "<TD style='padding-left:2'>" & adoRsGet("full_name") & "</TD>"
		strHTML = strHTML & "</TR>"
		nCounter = nCounter + 1
		adoRsGet.MoveNext 
	loop
	
	strHTML = strHTML & "<TR>"
	strHTML = strHTML & "<TR><TD colspan=4 height=5 style='border-bottom:#cccccc 1 solid'><span style='font-size:5px'>&nbsp;</span></TD></TR>"
	strHTML = strHTML & "<TD colspan=4 style='padding-left:2;padding-top:3'>Pages: "	
	
	For i=1 to adoRsGet.PageCount 
		If i = cint(page) Then
			strHTML = strHTML & "  " & i
		Else
			strHTML = strHTML & "  <a href=archive_list.asp?id=" & ID & "&page_no=" & i & ">" & i & "</a>"
		End If
	Next
	
	strHTML = strHTML & "</TD>"
	strHTML = strHTML & "</TR>"
	
	getArchiveData = strHTML
	
	adoRsGet.Close
	set adoRsGet = nothing
	adoCnGet.Close
	set adoCnGet = nothing
end function

%>
<html>

<head>
<base target=_self>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>Archive List</title>
<link rel="stylesheet" href="include/style.css" type="text/css">
<script language="JavaScript">
	function SubmitForm(action){
		if (action == 'rollback'){
			DocID = Form1.txtDocID.value;
			if ((Form1.chkContent.checked == false) && (Form1.chkAbstract.checked == false)){
				alert ("Choose whether you want to rollback content/abstract");
				return false;
			}
			if (confirm("Are you sure you want to rollback?") == false){
				return false;
			}
		}
		if (action == 'delete'){
			DocID = Form1.txtDocID.value;
			if (confirm("Are you sure want to delete the archive?") == false){
				return false;
			}
		}
		Form1.action = "archive_list.asp?id="+DocID+"&command="+action;
		Form1.submit();
	}
	function openWindowDialog(url,width,height){
	window.showModalDialog(url,window,
		"dialogWidth:"+width+"px;dialogHeight:"+height+"px;edge:Raised;center:Yes;help:No;resizable:Yes;status:No");
	}
</script>
</head>
<body class=dialog_body style="overflow:hidden;">

<table cellpadding=0 cellspacing=0 width=450>
<tr><td class="dialog_header_big" valign=middle><%=mid(sTitle,1,30)&".."%></td></tr>
</table>

<form id=Form1 name=Form1 method="post">

<table cellpadding=0 cellspacing=0 width=450 height=350>
<tr>
<td valign=top>
	<table cellpadding=0 cellspacing=0 width=100% style="margin-left:7;margin-bottom:3">
	<tr>
	<td style="padding-left:2">
	<input type=hidden name=txtDocID id=txtDocID value="<%=Request.querystring("id")%>">
	<span style="color:red;"><%=strMsg%></span></td>
	</tr>
	<tr>
	<td style="padding:2"><b>List of Archives</b></td>
	</tr>
	</table>
</td>
</tr>
<tr>
<td height=100% valign=top>
	<table cellpadding=0 cellspacing=0 width=390 style="margin-left:7">
	<%=strHTMLHeader%>
	<%=strHTMLResult%>
	</table>
</td>
</tr>
<tr><td>&nbsp;</td></tr>
<tr>
	<td align=right style="padding-right:8">Rollback the following fields:</td>
</tr>
<tr>
<td align=right style="padding-right:10">
	<input type=checkbox name=chkContent id=chkContent <%=sView%>>Content&nbsp;
	<input type=checkbox name=chkAbstract id=chkAbstract <%=sView%>>Abstract
</td>
</tr>
<tr>
<td align=right class=dialog_footer_big style="padding-bottom:10">
	<input type=button value=" close " onclick="self.close();">
	<input type=button value="rollback" onclick="SubmitForm('rollback');" <%=sView%>>
	<input type=button value="delete" onclick="SubmitForm('delete');" <%=sView%>>
</td>
</tr>
</table>

</form>

</body>
</html>
