<!-- #INCLUDE FILE='connection.asp' -->
<%
set adoCn = Server.CreateObject("ADODB.Connection")
adoCn.Open strConn1
set adoRs = Server.CreateObject("ADODB.Recordset")

strSQL = "SELECT document_id,date_start,date_end FROM [document] WHERE approval_status='pending_for_publishing'"

set adoRs = adoCn.Execute(strSQL)
while not adoRs.EOF
	blnPublish = false
	'CHECK NULL DATE
	if isnull(adoRs("date_start")) = false then
		if isnull(adoRs("date_end")) then
			if now() >= adoRs("date_start") then
				blnPublish = true
			end if
		else
			if now() >= adoRs("date_start") AND now() <= adoRs("date_end") then
				blnPublish = true
			end if
		end if
	end if
	nDocID=adoRs("document_id")
	'PUBLISH
	if blnPublish = true then
		PublishDocument nDocID
	end if
	adoRs.MoveNext
wend
adoRs.Close

strSQL = "SELECT document_id FROM document_published WHERE (now() >= date_end OR now() <= date_start) AND document_id <> 1"
set adoRs = adoCn.Execute(strSQL)
while not adoRs.EOF
	'DELETE
	nDocID=adoRs("document_id")		
	strSQL = "DELETE FROM [document_published] WHERE document_id=" & nDocID
	adoCn.Execute (strSQL)
	strSQL = "DELETE FROM [site_language] WHERE document_id=" & nDocID
	adoCn.Execute (strSQL)	
	adoRs.MoveNext
wend
adoRs.Close	

set adoRs = nothing
adoCn.Close
set adoCn = nothing
	
	
Function ConvertDate(dDate)

   If IsDate(dDate) = True Then
      dim dDay, dMonth, dYear, dHour, dMin

      dDay = Day(dDate)
      dMonth = Month(dDate)
      dYear   = Year(dDate)
      dHour = Hour(dDate)
      dMin = Minute(dDate)
	
      ConvertDate = dYear & "-" & Right(Cstr(dMonth + 100),2) & "-" & Right(Cstr(dDay + 100),2) & " " & dHour & ":" & dMin

   Else

      ConvertDate = Null

   End If

End Function

function PublishDocument(ID)
	Dim adoCnPublish
	Dim adoDocRs
	
	set adoCnPublish = server.CreateObject("ADODB.Connection")
	set adoDocRs = Server.CreateObject("ADODB.Recordset")
	
	adoCnPublish.Open strConn1
	
	adoCnPublish.BeginTrans
	
	'delete published document if any
	strSQL = "DELETE FROM [document_published] WHERE "
	strSQL = strSQL & "document_id = " & ID
	on error resume next
	adoCnPublish.execute strSQL
	if err.number <> 0 then
		adoCnPublish.RollbackTrans
		HandleError adoCnPublish,"trigger.asp - PublishDocument(ID) - Delete published document"
	end if
	

	'publish document now (insert into document_published)
	strSQL = "SELECT * FROM [document] WHERE document_id = " & ID
	on error resume next
	set adoDocRs = adoCnPublish.execute (strSQL)
	if err.number <> 0 then
		adoDocRs.Close
		set adoDocRs = nothing
		adoCnPublish.RollbackTrans
		HandleError adoCnPublish,"trigger.asp - PublishDocument(ID) - Select document"
	end if
	
	if not adoDocRs.EOF then
	
		'update document table
		'increment the version (the first segment +1 & the second segment=0)
		sVersion = adoDocRs("version")
		sFirstSegment = split(sVersion,".")(0)
		nSecondSegment = clng(split(sVersion,".")(1))
		sFirstSegment = sFirstSegment + 1
		sVersion = sFirstSegment & ".0"
	
	
		strSQL = "INSERT INTO document_published "
		strSQL = strSQL & "("
		strSQL = strSQL & "document_id,parent_document_id,[position],template_id,[type],"
		strSQL = strSQL & "[title],[sub_title],link_text,abstract,[content],"
		strSQL = strSQL & "search_keywords,search_description,author_id,last_updated_by,date_created,"
		strSQL = strSQL & "date_last_updated,date_published,file_name,file_size,[public],"
		strSQL = strSQL & "[version],date_start,date_end"
		strSQL = strSQL & ")"
		strSQL = strSQL & " VALUES "
		strSQL = strSQL & "("
		strSQL = strSQL & adoDocRs("document_id") & ","
		if isnull(adoDocRs("parent_document_id")) then
			nParentID = "null"
		else
			nParentID = adoDocRs("parent_document_id")
		end if
		strSQL = strSQL & nParentID & ","
		if isnull(adoDocRs("position")) then
			nPosition = "null"
		else
			nPosition = adoDocRs("position")
		end if
		strSQL = strSQL & nPosition & ","
		strSQL = strSQL & adoDocRs("template_id") & ","
		strSQL = strSQL & "'" & adoDocRs("type") & "',"
		strSQL = strSQL & "'" & replace("" & adoDocRs("title"),"'","''") & "',"
		strSQL = strSQL & "'" & replace("" & adoDocRs("sub_title"),"'","''") & "',"
		strSQL = strSQL & "'" & replace("" & adoDocRs("link_text"),"'","''") & "',"
		strSQL = strSQL & "'" & replace("" & adoDocRs("abstract"),"'","''") & "',"
		strSQL = strSQL & "'" & replace("" & adoDocRs("content"),"'","''") & "',"
		strSQL = strSQL & "'" & replace("" & adoDocRs("search_keywords"),"'","''") & "',"
		strSQL = strSQL & "'" & replace("" & adoDocRs("search_description"),"'","''") & "',"
		strSQL = strSQL & adoDocRs("author_id") & ","
		strSQL = strSQL & adoDocRs("last_updated_by") & ","
		strSQL = strSQL & "#" & ConvertDate(adoDocRs("date_created")) & "#,"
		strSQL = strSQL & "#" & ConvertDate(adoDocRs("date_last_updated")) & "#,"
		strSQL = strSQL & "#" & ConvertDate(now()) & "#,"
		strSQL = strSQL & "'" & replace("" & adoDocRs("file_name"),"'","''") & "',"
		strSQL = strSQL & "'" & replace("" & adoDocRs("file_size"),"'","''") & "',"
		strSQL = strSQL & "'" & adoDocRs("public") & "',"
		strSQL = strSQL & "'" & sVersion & "',"
		if isnull(adoDocRs("date_start")) then
			strSQL = strSQL & "null,"
		else
			strSQL = strSQL & "#" & ConvertDate(adoDocRs("date_start")) & "#,"
		end if
		if isnull(adoDocRs("date_end")) then
			strSQL = strSQL & "null"
		else
			strSQL = strSQL & "#" & ConvertDate(adoDocRs("date_end")) & "#"
		end if
		strSQL = strSQL & ")"
		
		on error resume next
		adoCnPublish.execute strSQL
		if err.number <> 0 then
			adoDocRs.Close
			set adoDocRs = nothing
			adoCnPublish.RollbackTrans
			HandleError adoCnPublish,strSQL '"trigger.asp - PublishDocument(ID) - Add published document"
		end if
		
	end if
	
	adoDocRs.Close 
	set adoDocRs = nothing
	
	'set approval status to "published" and increased version
	strSQL = "UPDATE [document] SET approval_status = 'published'"
	strSQL = strSQL & ",date_last_published = #" & ConvertDate(now()) & "# "
	strSQL = strSQL & ",[version]='" & sVersion & "' "
	strSQL = strSQL & "WHERE document_id = " & ID
	on error resume next
	adoCnPublish.Execute (strSQL)
	if err.number <> 0 then
		adoCnPublish.RollbackTrans
		HandleError adoCnPublish,"trigger.asp - PublishDocument(ID) - Update approval status to 'published'"
	end if
	
	adoCnPublish.CommitTrans
	adoCnPublish.Close
	set adoCnPublish = nothing
	
end function

sub HandleError(obj,pagename)
	obj.close
	set obj = nothing
	strErr = "<HTML><TITLE>Page Error</TITLE>"
	strErr = strErr & "<BODY><H1>Unable to process your request.</H1>"
	strErr = strErr & "<H3>Page: " & pagename & ".</H3>"
	strErr = strErr & "<H3>Number: " & err.Source & ".</H3>"
	strErr = strErr & "<H3>Problem Description: " & err.Description & "</H3>"
	strErr = strErr & "<H3>Please contact your administrator.</H3>"
	strErr = strErr & "</BODY></HTML>"
	Response.Write strErr
	Response.End
end sub
%>